package cc.fascinated.bat.command.impl.botadmin.premium;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "premiumadmin", description = "Set a guild as premium", botOwnerOnly = true, category = Category.BOT_ADMIN)
public class PremiumAdminCommand extends BatCommand {
    @Autowired
    public PremiumAdminCommand(@NonNull ApplicationContext context) {
        super.addSubCommand(context.getBean(SetSubCommand.class));
        super.addSubCommand(context.getBean(RemoveSubCommand.class));
    }
}
